-------------------------------------------------------
-- Created by Ben Cope of Imperial College (May 2005)
-- Internal Cordic Block for Primary Colour Correction
-------------------------------------------------------

LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.std_logic_arith.ALL;

LIBRARY work;
USE work.Constants.ALL;

ENTITY Cordic_block IS
 generic(
  n: INTEGER := 1);
 PORT(
  -- Input Signals
  clock : IN STD_LOGIC;
  d : IN STD_LOGIC;
--  n: IN INTEGER;
  x_in: IN Vector36;
  y_in: IN Vector36;

  -- Output Signals
  x_out: OUT Vector36;
  y_out: OUT Vector36);
END Cordic_block;

ARCHITECTURE inside OF Cordic_block IS

BEGIN

 P1: PROCESS

 VARIABLE shifted_x_in, shifted_y_in : Vector36;
 
 BEGIN
 
  WAIT UNTIL Rising_Edge(clock);
 
   shifted_x_in(35-n DOWNTO 0) := x_in(35 DOWNTO n);
	shifted_y_in(35-n DOWNTO 0) := y_in(35 DOWNTO n);

	IF (x_in(35) = '1') THEN
	 shifted_x_in(35 DOWNTO 35-n) := (OTHERS => '1');
   ELSE
	 shifted_x_in(35 DOWNTO 35-n) := (OTHERS => '0');
	END IF;

	IF (y_in(35) = '1') THEN
	 shifted_y_in(35 DOWNTO 35-n) := (OTHERS => '1');
   ELSE
	 shifted_y_in(35 DOWNTO 35-n) := (OTHERS => '0');
	END IF;

   IF (d = '1') THEN
	  x_out <= signed(x_in) - signed(shifted_y_in);
	  y_out <= signed(y_in) + signed(shifted_x_in);
	ELSE
	  x_out <= signed(x_in) + signed(shifted_y_in);
	  y_out <= signed(y_in) - signed(shifted_x_in);
	END IF;

 END PROCESS P1;

END inside;