-------------------------------------------------------
-- Created by Ben Cope of Imperial College (May 2005)
-- Multiplier for Primary Colour Correction
-------------------------------------------------------

LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.std_logic_arith.ALL;

ENTITY Multiplier_model IS
 PORT(
  -- Input Signals 
  C : IN STD_LOGIC;
  R : IN STD_LOGIC;
  CE : IN STD_LOGIC;
  A: IN STD_LOGIC_VECTOR(17 DOWNTO 0);
  B: IN STD_LOGIC_VECTOR(17 DOWNTO 0); 
  
  -- Output Signals
  P:OUT STD_LOGIC_VECTOR(35 DOWNTO 0));
END Multiplier_model;

ARCHITECTURE inside OF Multiplier_model IS

BEGIN

P1: PROCESS
BEGIN
 WAIT UNTIL Rising_Edge(C);
  IF (CE = '1') THEN
   P <= (OTHERS => '0');
  ELSE
   P <= signed(A)*signed(B);
  END IF;
END PROCESS P1;

END inside;
